import { ExtensionPreferences } from "resource:///org/gnome/Shell/Extensions/js/extensions/prefs.js";
import Adw from "gi://Adw";
import Gio from "gi://Gio";
import Gtk from "gi://Gtk";

export default class OBPreferences extends ExtensionPreferences {
    fillPreferencesWindow(window) {
        const settings = this.getSettings();
    
        const page = new Adw.PreferencesPage();
        const groupTarget = new Adw.PreferencesGroup({
            title: "Intensity of blur",
            description: "Default",
        });
        page.add(groupTarget);
        
        const BlurBrightness = new Adw.ActionRow({
            title: "Blur Brightness",
        });
        groupTarget.add(BlurBrightness);

        const BlurBrightnessAdjustment = new Gtk.Adjustment({
            value: settings.get_int("blur-brightness-light"),
            lower: 0,
            upper: 20,
            step_increment: 1,
        });

        const BlurBrightnessSpinButton = new Gtk.SpinButton({
            adjustment: BlurBrightnessAdjustment,
            numeric: true,
            valign: Gtk.Align.CENTER,
            halign: Gtk.Align.END,
        });

        settings.bind(
            "blur-brightness-light",
            BlurBrightnessSpinButton.get_adjustment(),
            "value",
            Gio.SettingsBindFlags.DEFAULT
        );

        BlurBrightness.add_suffix(BlurBrightnessSpinButton);
        BlurBrightness.activatable_widget = BlurBrightnessSpinButton;

        const BlurRadius = new Adw.ActionRow({
            title: "Blur Radius",
        });
        groupTarget.add(BlurRadius);

        const BlurRadiusAdjustment = new Gtk.Adjustment({
            value: settings.get_int("blur-radius-light"),
            lower: 0,
            upper: 20,
            step_increment: 1,
        });

        const BlurRadiusSpinButton = new Gtk.SpinButton({
            adjustment: BlurRadiusAdjustment,
            numeric: true,
            valign: Gtk.Align.CENTER,
            halign: Gtk.Align.END,
        });

        settings.bind(
            "blur-radius-light",
            BlurRadiusSpinButton.get_adjustment(),
            "value",
            Gio.SettingsBindFlags.DEFAULT
        );

        BlurRadius.add_suffix(BlurRadiusSpinButton);
        BlurRadius.activatable_widget = BlurRadiusSpinButton;
        
        const groupTarget2 = new Adw.PreferencesGroup({
            //title: "Intensity of blur",
            description: "Dark mode",
        });
        page.add(groupTarget2);
        
        const BlurBrightnessDark = new Adw.ActionRow({
            title: "Blur Brightness",
        });
        groupTarget2.add(BlurBrightnessDark);

        const BlurBrightnessDarkAdjustment = new Gtk.Adjustment({
            value: settings.get_int("blur-brightness-dark"),
            lower: 0,
            upper: 20,
            step_increment: 1,
        });

        const BlurBrightnessDarkSpinButton = new Gtk.SpinButton({
            adjustment: BlurBrightnessDarkAdjustment,
            numeric: true,
            valign: Gtk.Align.CENTER,
            halign: Gtk.Align.END,
        });

        settings.bind(
            "blur-brightness-dark",
            BlurBrightnessDarkSpinButton.get_adjustment(),
            "value",
            Gio.SettingsBindFlags.DEFAULT
        );

        BlurBrightnessDark.add_suffix(BlurBrightnessDarkSpinButton);
        BlurBrightnessDark.activatable_widget = BlurBrightnessDarkSpinButton;

        const BlurRadiusDark = new Adw.ActionRow({
            title: "Blur Radius",
        });
        groupTarget2.add(BlurRadiusDark);

        const BlurRadiusDarkAdjustment = new Gtk.Adjustment({
            value: settings.get_int("blur-radius-dark"),
            lower: 0,
            upper: 20,
            step_increment: 1,
        });

        const BlurRadiusDarkSpinButton = new Gtk.SpinButton({
            adjustment: BlurRadiusDarkAdjustment,
            numeric: true,
            valign: Gtk.Align.CENTER,
            halign: Gtk.Align.END,
        });

        settings.bind(
            "blur-radius-dark",
            BlurRadiusDarkSpinButton.get_adjustment(),
            "value",
            Gio.SettingsBindFlags.DEFAULT
        );

        BlurRadiusDark.add_suffix(BlurRadiusDarkSpinButton);
        BlurRadiusDark.activatable_widget = BlurRadiusDarkSpinButton;

        window.add(page);
    }
}
